import { system, world } from "@minecraft/server";

world.afterEvents.playerSpawn.subscribe(({initialSpawn}) => {
    if (initialSpawn && world.getPlayers().length == 1) world.sendMessage(`§eThanks for installing §6Unbreakable Items V19 by TrayePlays\n§eIf you need any assistance with the addon join the discord: §9discord.gg/GHzNqpZ4Bu`)
})

system.afterEvents.scriptEventReceive.subscribe(({id, sourceEntity}) => {
    if (id == "traye:repair") {
        const player = sourceEntity
        for (let i = 0; i < player.getComponent("inventory").inventorySize; i++) {
            if (player.getComponent("inventory").container.getItem(i)?.typeId == "minecraft:trident") {
                const item = player.getComponent("inventory").container.getItem(i).clone()
                item.getComponent("durability").damage = 0
                player.getComponent("inventory").container.setItem(i, item)
            } 
        }
    }
})

world.afterEvents.entityRemove.subscribe(({typeId}) => {
    if (typeId == "minecraft:thrown_trident") {
        for (const player of world.getPlayers()) {
            player.runCommand("execute as @s[hasitem={item=trident,quantity=!0}] run scriptevent traye:repair")
        }
    }
})

world.afterEvents.itemUse.subscribe(({itemStack, source: player}) => {
    const eqList = ["_helmet", "_chestplate", "_leggings", "_boots", "elytra"]
    let pass = true;
    for (const eq of eqList) {
        if (itemStack?.typeId.includes(eq)) pass = false;
    }
    if (itemStack?.getComponent("durability") && pass) {
        const item = itemStack.clone()
        item.getComponent("durability").damage = 0;
        player?.getComponent("inventory").container.setItem(player.selectedSlotIndex, item)
    }
})

world.afterEvents.entityHitEntity.subscribe(({damagingEntity, hitEntity}) => {
    const listOfEqSlots = ["Mainhand", "Offhand", "Head", "Chest", "Legs", "Feet"]
    for (const eq of listOfEqSlots) {
        if (damagingEntity?.getComponent("equippable")?.getEquipment(eq)?.getComponent("durability")) {
            const item = damagingEntity.getComponent("equippable").getEquipment(eq)
            item.getComponent("durability").damage = 0;
            damagingEntity?.getComponent("equippable").setEquipment(eq, item)
        }
        if (hitEntity?.getComponent("equippable")?.getEquipment(eq)?.getComponent("durability")) {
            const item = hitEntity.getComponent("equippable").getEquipment(eq)
            item.getComponent("durability").damage = 0;
            hitEntity?.getComponent("equippable").setEquipment(eq, item)
        }
    }
})

world.afterEvents.playerBreakBlock.subscribe(({player}) => {
    const listOfEqSlots = ["Mainhand", "Offhand", "Head", "Chest", "Legs", "Feet"]
    for (const eq of listOfEqSlots) {
        if (player?.getComponent("equippable")?.getEquipment(eq)?.getComponent("durability")) {
            const newItem = player?.getComponent("equippable")?.getEquipment(eq)?.clone()
            newItem.getComponent("durability").damage = 0
            player?.getComponent("equippable").setEquipment(eq, newItem)
        }
    }
})

system.runInterval(() => {
    for (const player of world.getPlayers().filter(a => a.isGliding == true)) {
        const eq = player.getComponent("equippable")
        const item = eq.getEquipment("Chest").clone();
        item.getComponent("durability").damage = 0
        eq.setEquipment("Chest", item)
    }
}, 20)